import 'dart:ffi';

final class CanFdMsg extends Struct {
  @Uint32()
  external int id; // 报文ID,bit[30]-RTR,bit[31]-IDE,bit[28..0]-ID

  @Uint8()
  external int dlc; // 数据字节长度，可设置为-0,1,2,3,4,5,6,7,8,12,16,20,24,32,48,64

  @Uint8()
  external int flags; // bit[0]-BRS,bit[1]-ESI,bit[2]-FDF,bit[6..5]-Channel,bit[7]-RXD

  @Uint8()
  external int res0; // 保留

  @Uint8()
  external int res1; // 保留

  @Uint32()
  external int timeStamp; // 帧接收或者发送时的时间戳，单位为10us

  @Array<Uint8>(64)
  external Array<Uint8> data;
}